//flakCannon.cs
//Ephialtes

//audio
datablock AudioProfile(flakExplosionSound)
{
   filename = "Add-Ons/Weapon_Spear/spearHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(flakHitSound)
{
   filename = "Add-Ons/Weapon_Bow/arrowHit.wav";
   description = AudioClose3d;
   preload = true;
};

//muzzle flash effects
datablock ParticleData(flakFlashParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flakFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flakFlashParticle";
};

datablock ParticleData(flakSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.2";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flakSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flakSmokeParticle";
};

//trails
datablock ParticleData(flakTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 225;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.2 0.2 0.4";
	colors[1]     = "0.6 0.4 0.0 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flakTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flakTrailParticle";
};

datablock ParticleData(flakTrailParticleB)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 225;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.2 0.2 0.4";
	colors[1]     = "0.6 0.4 0.0 0.0";
	sizes[0]      = 0.55;
	sizes[1]      = 0.65;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flakTrailEmitterB)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flakTrailParticleB";
};

//Explosion particles
datablock ParticleData(flakExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(flakExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flakExplosionParticle";
};

datablock ParticleData(flakExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flakExplosionRingEmitter)
{
	lifeTimeMS = 50;

   	ejectionPeriodMS = 1;
   	periodVarianceMS = 0;
   	ejectionVelocity = 5;
   	velocityVariance = 0.0;
   	ejectionOffset   = 0.0;
   	thetaMin         = 89;
   	thetaMax         = 90;
   	phiReferenceVel  = 0;
   	phiVariance      = 360;
   	overrideAdvance = false;
   	particles = "flakExplosionRingParticle";
};

//Explosion datablocks
datablock ExplosionData(flakShellExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionsphere1.dts";
   soundProfile = flakExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = rocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = rocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 7;
   radiusDamage = 100;

   impulseRadius = 10;
   impulseForce = 4000;
};

datablock ExplosionData(flakExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = gunExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";

   damageRadius = 0;
   radiusDamage = 100;

   impulseRadius = 0;
   impulseForce = 4000;
};

//Projectiles
AddDamageType("FlakShellDirect",   '<bitmap:Add-Ons/Weapon_FlakCannon/ci_flakCannon> %1',    '%2 <bitmap:Add-Ons/Weapon_FlakCannon/ci_flakCannon> %1',1,1);
AddDamageType("FlakShellRadius",   '<bitmap:Add-Ons/Weapon_FlakCannon/ci_flakCannonRadius> %1',    '%2 <bitmap:Add-Ons/Weapon_FlakCannon/ci_flakCannonRadius> %1',1,0);
datablock ProjectileData(flakProjectileA)
{
   projectileShapeName = "./flakShell.dts";
   directDamage        = 60;
   directDamageType    = $DamageType::FlakShellDirect;
   radiusDamageType    = $DamageType::FlakShellRadius;

   brickExplosionRadius = 4;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1000;
   verticalImpulse     = 1000;
   explosion           = flakShellExplosion;
   particleEmitter     = flakTrailEmitterB;

   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 5000;
   fadeDelay           = 5000;
   bounceElasticity    = 0.6;
   bounceFriction      = 0.5;
   isBallistic         = true;
   gravityMod = 1.0;
   explodeOnDeath = true;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "0.9 0.3 0.1";
};

AddDamageType("FlakDirect",   '<bitmap:Add-Ons/Weapon_FlakCannon/ci_flakShrapnel> %1',    '%2 <bitmap:Add-Ons/Weapon_FlakCannon/ci_flakShrapnel> %1',1,0);
datablock ProjectileData(flakProjectileB)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::FlakDirect;
   radiusDamageType    = $DamageType::FlakDirect;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse     = 10;
   explosion           = flakExplosion;
   particleEmitter     = flakTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 5000;
   lifetime            = 5000;
   fadeDelay           = 5000;
   bounceElasticity    = 0.6;
   bounceFriction      = 0.5;
   isBallistic         = true;
   gravityMod = 0.8;
   explodeOnDeath = false;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "0.9 0.3 0.1";
};

datablock ProjectileData(flakProjectileBCol)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::FlakDirect;
   radiusDamageType    = $DamageType::FlakDirect;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse     = 10;
   explosion           = flakExplosion;
   particleEmitter     = flakTrailEmitter;

   muzzleVelocity      = 1;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 1000;
   bounceElasticity    = 0.6;
   bounceFriction      = 0.3;
   isBallistic         = true;
   explodeOnDeath      = true;
   gravityMod          = 0.8; 

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//Item
datablock ItemData(FlakItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./flakcannon.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Flak Cannon";
	iconName = "./flakCannon";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = flakImage;
	canDrop = true;
};

//Image
datablock ShapeBaseImageData(flakImage)
{
   // Basic Item properties
   shapeFile = "./flakcannon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.1 0.68 -0.2";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FlakItem;
   ammo = " ";
   projectile = flakProjectileA;
   projectileType = Projectile;
   minShotTime = 1800;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = flakItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]			   = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                     = "Fire";
	stateTransitionOnTimeout[2]      = "Smoke";
	stateTimeoutValue[2]             = 0.2;
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateSequence[2]                 = "Fire";
	stateScript[2]                   = "onFire";
	stateWaitForTimeout[2]		   = true;
	stateEmitter[2]			   = flakFlashEmitter;
	stateEmitterTime[2]		   = 0.05;
	stateEmitterNode[2]		   = "muzzleNode";
	stateSound[2]			   = gunShot1Sound;

	stateName[3] 			   = "Smoke";
	stateEmitter[3]		         = flakSmokeEmitter;
	stateEmitterTime[3]		   = 1.2;
	stateEmitterNode[3]		   = "muzzleNode";
	stateTimeoutValue[3]             = 0.4;
	stateTransitionOnTimeout[3]      = "CoolDown";

	stateName[4]			   = "CoolDown";
	stateEmitter[4]			   = flakSmokeEmitter;
	stateSequence[4]			   = "eject";
	stateEmitterNode[4]		   = "ejectPoint";
	stateEmitterTime[4]		   = 0.3;
	stateTimeoutValue[4]             = 0.4;
	stateTransitionOnTimeout[4]	   = "Reload";

	stateName[5] 			   = "Reload";
	stateSequence[5]			   = "reload";
	stateTimeoutValue[5]             = 0.8;
	stateTransitionOnTimeout[5]      = "Ready";
};

function flakImage::onFire(%this,%obj,%slot)
{
	if(%obj.getImageAmmo(%slot))
	{
		%projectile = flakProjectileB;
		%spread = 0.003;
		%shellcount = getRandom(10,15);
	
		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector,(%projectile.muzzleVelocity+getRandom(-30,30)));
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				originPoint = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
	else
	{
		%projectile = flakProjectileA;
		%spread = 0.0015;
		%shellcount = 1;

		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				originPoint = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};	
			MissionCleanup.add(%p);
		}
		return %p;	
	}
}

function flakProjectileB::onCollision(%this,%obj,%col,%fade,%pos,%norm)
{
	if(%col.getClassName() $= "Player")
		%obj.setDataBlock(flakProjectileBCol);
	else
	{
		%obj.numBounces++;
		serverPlay3D(hammerHitSound,%obj.getTransform());
		if(vectorDist(%obj.lastBounce,getSimTime()) < 200)
		{
			%obj.schedule(10,"delete");
			return;
		}
		%obj.lastBounce = getSimTime();
	}
	Parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
}

function flakProjectileB::Damage(%this,%obj,%col,%fade,%pos,%norm)
{
	%bounces = %obj.numBounces;
	%damage = %this.directDamage-(%bounces*3);	
	%col.damage(%obj,%pos,%damage,%this.directDamageType);
}

function flakProjectileBCol::Damage(%this,%obj,%col,%fade,%pos,%norm)
{
	%bounces = %obj.numBounces;
	%damage = %this.directDamage-(%bounces*3);	
	%col.damage(%obj,%pos,%damage,%this.directDamageType);
}

package FlakCannon
{
	function armor::onTrigger(%this,%player,%slot,%val)
	{
		if(%slot $= 4 && %player.getMountedImage(0) $= flakImage.getID())
		{
			if(%val)
			{
				%player.flakTrigEnable = getSimTime();
			}
			else
			{
				if(vectorDist(%player.flakTrigEnable,getSimTime()) < 500)
				{
					%player.setImageAmmo(0,0);
					%player.setImageTrigger(0,1);
					%player.setImageTrigger(0,0);
					%player.setImageAmmo(0,1);
				}
			}
		}
		else
			Parent::onTrigger(%this,%player,%slot,%val);
	}
};
ActivatePackage(FlakCannon);